/*----------------------------------------------------
  MakeKeys.c -- 室  ⥪  ணࠬ ࠡ⪨
		ᨢ 祢 ଠ樨.
  ----------------------------------------------------
  ࠡ⠫ ..஢, .᪢, ﭢ 1995 .
  (c) 1995,   ᯮ짮   ஢.
  ----------------------------------------------------
   ணࠬ ᯥ樠쭮 ⠢  㡫樨
   "".
  ----------------------------------------------------
*/
#include <io.h>		// open, filelength
#include <fcntl.h>	// O_RDONLY
#include <ctype.h>	// toupper,isdigit
#include <stdlib.h>	// strtoul
#include <stdio.h>	// printf
#include <dir.h>	// MAXPATH
#include <memory.h>	// setmem
#include <string.h>	// strlen
#include "gost.h"	//   ⨯ 
// ࠧ   -   ⥭ 8
#define  BUFFER_SIZE    8192

//  ᪨ 

extern unsigned _stklen=BUFFER_SIZE+4096; // ࠧ 

typedef enum
{
  O_K_=0,	    //  O.K.
  errInvalidFlag,   //  䫠 맮 ணࠬ
  errBadSynchro,    // ୮  ᨭய뫪
  errBadDefault,    // ୮  ᨭய뫪
  errNoParm,	    //  ࠬ 맮
  errBadKey,	    // 宩 䠩 
  errBadXCHT,	    // 宩 䠩  ⠡楩 
  errListFailure,   // 訡  䠩-ᯨ᪥
  errBadKeyLength,  // ୮   
  errZeroKeyLength, //  㫥  
  errKeyFailure     // 訡  䠩  箬
} errList;

unsigned char chtab[1024];

Item	Key[32];	// ࠧ 

Item    Synchro[2]=	// ᨭய뫪
{
  0UL,0UL
};

errList code=O_K_;	//  室

int	ParmCount= 0;   // 稪 ࠬ஢
static unsigned
  ListProcessed=0,      // 稪 ࠬ஢
  KeyMade=0,            // 稪 祩
  DefaultLen=32;	//    㬮砭

unsigned char Buffer[BUFFER_SIZE],
	      *BufferPtr=Buffer+BUFFER_SIZE;

// ⨯ 㭪権

errList ProcessKey	(char *parameter);
errList ProcessItem	(char *parameter);
errList	SignalError     (errList errType,
			 char *errPlace);
errList loadCht		(char *chtFile);
errList loadKey		(char *keyFile);
errList	execute		(void);

//  ணࠬ 

errList	main(int argc, char *argv[])
{
  unsigned short i;

  printf("ணࠬ ࠡ⪨ 祩   "
	 "ਯ⮣᪮ ⬠  28147-89\n"
	 "⠢ ..஢, ﭢ 1995 ,"
	 " ᢮ ᯮ짮  ஢\n");

  if (argc==1)
    printf(
" ᪠:  \"makekeys [] ᯨ᪨ [[]"
	" ᯨ᪨]...\"         ,:\n"
"   -    ᪮쪮 ᫥"
	" ⮢:\n"
"    /K<䠩> -  䠩  箬,   "
	" <䠩> -  ⨬\n"
"              MS-DOS  䠩.\n"
"              䠩  箬   "
	"32  256 ⮢\n"
"              㬮砭 ᯮ ਢ"
	" 㫥 .\n"
"    /C<䠩> -  䠩  ⠡楩 "
	"  - 256  1024 \n"
"              㬮砭 ᯮ ਢ쭠"
	" ⠡ .\n"
"    /SXXXX -  ᨭய뫪,  XXXX - "
	"8( )-ࠧ來\n"
"             16-筮 楫    થ஢"
	" ᭮\n"
"              㬮砭 ᯮ 㫥"
	" ᨭய뫪.\n"
"    /LNNNN -     㬮砭 -  "
	"NNNN - 筮 楫\n"
"              , ᫨ ࠬ   ,"
	" ⠥ ࠢ 32\n"
"  ᯨ᪨ -    ᪮쪮 ࠧ"
	" ஡  䠩,\n"
"   ᯨ᪠ ⥫ 祩.   "
	"ᯨ᮪ ᮤন ப\n"
"  ਥ, 稭騥  窨  ⮩ "
	" ஡쭮 ᨬ,\n"
"   ப ⥫ , 騥 ᫥騩"
	" ଠ:\n"
"  <䠩> []\n"
"   䠩   -   ࠧ 䠩   "
	" ,   뢠\n"
"   筮 ⥬,  㬮砭 ࠢ 祭,"
	"  箬 /L\n"
  );
  else
  {
//  横 ந ਢ ⠡ 
//  , ᫨ 㤥 樠஢  chtab
    for (i=0; i<1024; i++) chtab[i]=i;

// 横 ᬮ  ப
    while (*++argv)
      if (
	(code=(**argv=='/' ? ProcessKey : ProcessItem)
		   (*argv))   != O_K_)
	break;

    printf("KeyMaker: ࠡ⠭ %d ᯨ᪮,"
	" ᤥ %d 祩\n",ListProcessed,KeyMade);

    return code;
  }
  return O_K_;
}

// ࠡ⪠ 祩 [/x...]  ப

errList	ProcessKey(char *parameter)
{
  char *c;

  ++parameter;
  switch (toupper(*(parameter++)))// 롮  㪢
  {
    case 'K':
      if(loadKey(parameter) != O_K_)
	return errBadKey;
      break;
    case 'C':
      if (loadCht(parameter) != O_K_)
	return errBadXCHT;
      break;
    case 'S':
      if (strlen(parameter)==0 ||
	 (Synchro[0]=strtoul(parameter,&c,16),*c))
	return SignalError(errBadSynchro,parameter);
      break;
    case 'L':
      if (strlen(parameter)==0 ||
	 (DefaultLen=strtoul(parameter,&c,10),*c))
	return SignalError(errBadDefault,parameter);
      break;
    default:
      return  SignalError(errInvalidFlag,parameter-2);
  }
  return O_K_;
}

// ⠭ ० ᮣ᭮ 䫠 맮

errList	ProcessItem(char *parameter)
{
  FILE *KeyList,*KeyFile;

// ⠥  ᯨ᪮ 䠩-祩
  if ((KeyList=fopen(parameter,"rt"))==NULL)
    return SignalError(errListFailure,parameter);
  else
  {
    unsigned char buffer[MAXPATH+10],*p;

    while (fgets(buffer,MAXPATH+10,KeyList))
      if (*buffer>' ' && *buffer!=';')
      {
	unsigned short KeyLength=DefaultLen;
	for (p=buffer; *p > ' ' && *p != ';'; p++);
	if (*p==';') *p=0;
	else if(*p)
	{
	  *p=0;
	  while(*++p && *p<=' ');
	  if(isdigit(*p))
	    KeyLength=atoi(p);
	  else if( *p && *p != ';')
	    return SignalError(errBadKeyLength,p);
	}
	if(KeyLength==0)
	  return SignalError(errZeroKeyLength,NULL);
	if((KeyFile=fopen(buffer,"wb"))==NULL)
	  return SignalError(errKeyFailure,buffer);
	while(KeyLength)
	{
	  unsigned short register QuantSize;

	  if(BufferPtr-Buffer>=BUFFER_SIZE)
	    gamme(Key,Synchro,chtab,BufferPtr=Buffer,
		   BUFFER_SIZE/sizeof(CrBlock));
	  QuantSize=(KeyLength > BUFFER_SIZE ?
			      BUFFER_SIZE : KeyLength);

	  if(fwrite(BufferPtr,1,QuantSize,KeyFile) <
	      QuantSize)
	    return fclose(KeyFile),
		      SignalError(errKeyFailure,buffer);
	  KeyLength-=QuantSize;
	  BufferPtr+=QuantSize;
	}
      if (fclose(KeyFile))
	return SignalError(errKeyFailure,buffer);
      KeyMade++;
      }
  }
  ListProcessed++;
  return O_K_;
}

// 㧪 ⠡ 

errList loadCht(char *ChtFile)
{
  int	handle;
  unsigned long  FileSize;
  unsigned char  buffer[128];

  if ((handle=open(ChtFile,O_RDONLY))==-1 ||
       ((FileSize=filelength(handle)) != 128 &&
			      FileSize != 1024) ||
    read(handle,
      FileSize==128 ? buffer : chtab,FileSize)==-1)
    return errBadKey;

  if (FileSize == 128) ExpCht(buffer,chtab);
  close(handle);
  return O_K_;
}

// 㧪 

errList loadKey(char *KeyFile)
{
  int	handle,FileSize;
  unsigned char  buffer[32];

  if ((handle=open(KeyFile,O_RDONLY))==-1 ||
       ((FileSize=filelength(handle)) != 32 &&
			      FileSize != 128) ||
	  read(handle, FileSize==32 ?
            (void*) buffer : (void*) Key, FileSize)==-1)
    return errBadKey;

  if (FileSize==32) ExpKey31(buffer,Key);
  close(handle);
  return O_K_;
}

// 뤠 ᮮ饭  訡

errList	SignalError(errList errType, char *errPlace)
{
  char *errText[]=
  {
  " 䫠 맮 ணࠬ - %s\n",
  "୮  ᨭய뫪 - %s\n",
  "୮     㬮砭 - %s\n",
  " ࠬ-ᯨ᪨ 䠩 祩\n",
  "୮  䠩  室 箬 - %s\n",
  "୮  䠩  ⠡楩  - %s\n",
  "訡  䠩  ᯨ᪮ 䠩-祩 - %s\n",
  "     - %s\n",
  " 㫥  ,  ⨬\n",
  "訡  ⨨/ 䠩  箬 - %s\n"
  };
  printf(errText[errType-1],errPlace);
  return errType;
}
