/*----------------------------------------------------------
  MakePsws.c -- ணࠬ ࠡ⪨ ᨢ ஫쭮
		ଠ樨.
  ----------------------------------------------------------
  ࠡ⠫ ..஢, .᪢, ५- 1995 .
  (c) 1995,   ᯮ짮   ஢.
  ----------------------------------------------------------
  ᯫ⭮ ਫ    "".
  ----------------------------------------------------------
*/
#include <io.h>		// open, filelength
#include <fcntl.h>	// O_RDONLY
#include <ctype.h>	// toupper,isdigit
#include <stdlib.h>	// strtoul
#include <stdio.h>	// printf
#include <dir.h>	// MAXPATH
#include <memory.h>	// setmem
#include <string.h>	// strlen
#include "gost.h"	//   ⨯ 

#define  BUFFER_SIZE    1024
#define  MAX_ALPHABET     16
#define  MAX_GROUP        16

//  ᪨ 

typedef enum
{
  O_K_=0,	    	//  O.K.
  errInvalidFlag,   	//  䫠 맮 ணࠬ
  errBadSynchro,    	// ୮  ᨭய뫪
  errInsufficientParm,	// 筮 ࠬ஢ 맮
  errTooManyParm,	// ᫨誮  ࠬ஢ 맮
  errBadKey,	    	// 宩 䠩 
  errBadXCHT,	    	// 宩 䠩  ⠡楩 
  errBadKeyLength,  	// ୮  ᫮ ஫
  errZeroKeyLength, 	//  㫥 ᫮ ஫
  errKeyFailure,     	// 訡  䠩  箬
  errBadPWNumber,	// ୮  ᫮ ࠬ஢

  errItemCountExceed,   // ॢ襭 ᫮ 㯯 ᨬ
  errPWCFileError,      // 訡  䠩 䨣樨
  errBadPWCFileFormat,  //  ଠ 䠩 䨣樨
  errBadPWCNumberItem,  // -  -ࠧ⥫
  errOddPWCItemNumber,  // ⭮ ᫮ ᥫ  ப
  errAlphabetCountExceed, // ॢ襭 ᫮ 䠢⮢
  errInvalidAlphabetRef,// 뫪  騩 䠢
  errPWsFileError       // 訡  䠩 ஫
} errList;

struct
{
  char	*alpha;         // 㪠⥫  䠢
  unsigned int power;   // 魮 䠢
} Alphabet [MAX_ALPHABET];  // ⥫ 䠢⮢

union
{
  unsigned char seq [MAX_GROUP*2];
  struct
  {
    unsigned char AlphaNo;  // # 䠢
    unsigned char SymbolNo; // ᫮ ᨬ
  } stru [MAX_GROUP];
} item;			//  ᠭ

unsigned char chtab[1024];

Item	Key[32];	// ࠧ 

Item    Synchro[2]=	// ᨭய뫪
{
  0UL,0UL
};

errList code=O_K_;	//  室

char	 buffer[BUFFER_SIZE];
unsigned PWNeed=0;	// ॡ饥 ⢮ ஫
short	 PrintPWNo=0;	// ਧ, ॡ  
unsigned ItemCount;	// 稪 ᫮ ⮢
unsigned ParmCount=-1;	// 稪 ࠬ஢


// ⨯ 㭪権

errList ProcessKey	(char *parameter);
errList ProcessItem	(char *parameter);
errList	SignalError     (errList errType, char *errPlace);
errList loadCht		(char *chtFile);
errList loadKey		(char *keyFile);
errList	execute		(void);

unsigned char getRandomByte (void);

typedef errList Processor   (char *string);

Processor BuildPwsParmTable,// ஥ ⠡
	  GetPWNumber,  // । ᫠ ஫
	  makePWs;      // ஥ ஫

Processor *processor[]=
{
	BuildPwsParmTable,  // ஥ ⠡
	GetPWNumber,	// । ᫠ ஫
	makePWs 	// ஥ ஫
};

//  ணࠬ 

errList	main (int argc, char *argv[])
{
  unsigned short i;

  printf("ணࠬ ࠡ⪨ ஫   "
	 "ਯ⮣᪮ ⬠  28147-89"
	 "⠢ ..஢,   1995 ,"
	 "  ᢮ ᯮ짮  ஢\n");

  if (argc==1)
    return printf(
" ᪠:  \"makepsws [] 䨣 "
	"⢮ १\", :\n"
"   -    ᪮쪮 ᫥"
	" ⮢:\n"
"    /K<䠩> -  䠩  箬,   "
	" <䠩> -  ⨬\n"
"              MS-DOS  䠩.\n"
"              䠩  箬   "
	"32  256 ⮢\n"
"              㬮砭 ᯮ ਢ"
	" 㫥 .\n"
"    /C<䠩> -  䠩  ⠡楩 "
	"  - 256  1024 \n"
"              㬮砭 ᯮ ਢ쭠"
	" ⠡ .\n"
"    /SXXXX -  ᨭய뫪,  XXXX - "
	"8( )-ࠧ來\n"
"             16-筮 楫    થ஢"
	" ᭮\n"
"              㬮砭 ᯮ 㫥"
	" ᨭய뫪.\n"
"    /L - ।뢠 뢮  ஫  "
	"ᯨ᪥ ࠡ뢠 ஫\n"
"  䨣 - 䠩 ᠭ 䨣樨 ஫\n"
"  ⢮   - ⢮ ࠡ뢠 ஫\n"
"  १    - 䠩   ᣥ஢ ஫\n"
  ),-1;
  else
  {
//  横 ந ਢ ⠡ 
//  , ᫨ 㤥 樠஢  chtab
    for (i=0; i<1024; i++) chtab[i]=i;

// 横 ᬮ  ப
    while (*++argv)
      if (
	(code=(**argv=='/' ? ProcessKey : ProcessItem)
		   (*argv))   != O_K_)
	break;
    return ( code == O_K_ && ParmCount < 2 ) ?
      SignalError(errInsufficientParm, NULL):
      code;
  }
}

// ࠡ⪠ 祩 [/x...]  ப

errList	ProcessKey (char *parameter)
{
  char *c;

  ++parameter;
  switch (toupper(*(parameter++)))// 롮  㪢
  {
  case 'K':
    if(loadKey(parameter) != O_K_)
      return errBadKey;
    break;
  case 'C':
    if (loadCht(parameter) != O_K_)
      return errBadXCHT;
    break;
  case 'S':
    if (strlen(parameter)==0 ||
       (Synchro[0]=strtoul(parameter,&c,16),*c))
      return SignalError(errBadSynchro,parameter);
    break;
  case 'L':
    PrintPWNo = 1;
    break;
  default:
    return  SignalError(errInvalidFlag,parameter-2);
  }
  return O_K_;
}

// ࠡ⪠ 祢 ࠬ஢  ப

errList	ProcessItem (char *parameter)
{
  return
    ++ParmCount >= 3 ?
    SignalError (errTooManyParm, parameter) :
    processor[ParmCount](parameter);
}

// 㧪 ⠡ 

errList loadCht(char *ChtFile)
{
  int	handle;
  unsigned long  FileSize;
  unsigned char  buffer[128];

  if ((handle=open(ChtFile,O_RDONLY))==-1 ||
       ((FileSize=filelength(handle)) != 128 &&
			      FileSize != 1024) ||
    read(handle,
      FileSize==128 ? buffer : chtab,FileSize)==-1)
    return errBadKey;

  if (FileSize == 128) ExpCht(buffer,chtab);
  close(handle);
  return O_K_;
}

// 㧪 

errList loadKey(char *KeyFile)
{
  int	handle,FileSize;
  unsigned char  buffer[32];

  if ((handle=open(KeyFile,O_RDONLY))==-1 ||
       ((FileSize=filelength(handle)) != 32 &&
			      FileSize != 128) ||
	  read(handle, FileSize==32 ?
            (void*) buffer : (void*) Key, FileSize)==-1)
    return errBadKey;

  if (FileSize==32) ExpKey31(buffer,Key);
  close(handle);
  return O_K_;
}

// 뤠 ᮮ饭  訡

errList	SignalError(errList errType, char *errPlace)
{
  char *errText[]=
  {
  " 䫠 맮 ணࠬ - %s\n",
  "୮  ᨭய뫪 - %s\n",
  "   室 ࠬ஢\n",
  "譨 祢 ࠬ 맮 - \"%s\"\n",
  "୮  䠩  室 箬 - %s\n",
  "୮  䠩  ⠡楩  - %s\n",
  "     - %s\n",
  " 㫥  ,  ⨬\n",
  "訡  ⨨/ 䠩  箬 - %s\n",
  "᫮ ஫   㫥  楫"
	"   - \"%s\"\n",

  "ॢ襭 ।쭮 ᫮ 㯯 ᨬ  䠩"
	" 䨣樨 %s\n",
  "訡  ࠡ  䠩 䨣樨 - %s\n",
  " ଠ 䠩 䨣樨 - %s\n",
  " ᨬ  ப ࠬ஢  䠩 %s\n",
  "⭮ ᫮ ᫮ ⮢  ப ᠭ\n",
  "ॢ襭 ।쭮 ᫮ 㯯 䠢⮢  䠩"
	" 䨣樨 %s\n",
  "뫪  騩 䠢  䠩 %s\n",
  "訡  ࠡ  䠩 ஫ - %s\n"
  };
  printf(errText[errType-1],errPlace);
  return errType;
}
//--------------------------------------------------------

// ஥ ⠡ 䨣樨 ஫
// 㥬 ࠡ⪠:     䠩 
// ७   ७ .pwc

errList BuildPwsParmTable (char *PWCFileName)
{
  FILE  *PWCFile;	// 䠩  ᠭ 䨣樨
  int	c,n;		// ᯮ⥫ ६
  int   AlphabetNumber; // 稪 䠢⮢
  char  *b;		// 㪠⥫    


  if ( (PWCFile= fopen(PWCFileName,"rt")) == NULL)
    return SignalError (errPWCFileError, PWCFileName);

			// ய᪠ ப ਥ
  while ( c=getc(PWCFile),
	  c == ' ' || c == ';' || c == '\t' || c == '\n' )
    while ( c != '\n' && c != EOF )
      c=getc(PWCFile);

			//  ᫮ ࠬ஢ ஫
  for ( ItemCount = 0; n = c-'0', isdigit(c) ; ItemCount++ )
  {
    if ( ItemCount > MAX_GROUP * 2 )
      return SignalError ( errItemCountExceed, PWCFileName );
    while ( c=getc(PWCFile), isdigit(c) )
      n *= 10, n += c-'0';
    item.seq [ItemCount] = n;
    while ( c==' ' || c== '\t' )
      c = getc(PWCFile);
  }

			// ⨫ ᨬ - ନ
  switch ( c )
  {
    case ';':
      while ( c != '\n' && c != EOF )
	c=getc(PWCFile);
      if ( c==EOF )
	goto caseEOF;

    case '\n':
      break;

    case EOF: caseEOF:
      return SignalError (errBadPWCFileFormat, PWCFileName);

    default:
      return SignalError (errBadPWCNumberItem, PWCFileName);
  }

			// ஢ઠ ४⭮ ࠬ஢
  if ( ItemCount == 1)  //  ⢥ 㯯 ᪫祭
  {
    ItemCount++ ;
    item.stru->SymbolNo = item.stru->AlphaNo;
    item.stru->AlphaNo  = 1;

  }
  if ( ItemCount & 1)   //   ⭮ ᫮ -⮢
    return SignalError (errOddPWCItemNumber, PWCFileName);
  ItemCount >>= 1;      // ᫮ 㯯  

			// 뢠 䠢
  for ( AlphabetNumber=0, b=buffer; c=getc(PWCFile), c != EOF ;)
  {
    if ( c != ' ' && c != ';' && c != '\t' && c != '\n' )
    {
      if ( AlphabetNumber >= MAX_ALPHABET )
	return SignalError ( errAlphabetCountExceed, PWCFileName );
      Alphabet[AlphabetNumber].power = 0;
      Alphabet[AlphabetNumber].alpha = b;
      do
      {
	*(b++) = c;
	c=getc(PWCFile);
	Alphabet[AlphabetNumber].power++;
      }
      while ( c!=' ' && c!=';' && c!='\t' && c!='\n' && c!=EOF );
      AlphabetNumber++;
      *(b++) = '\000';
    }
    while ( c != '\n' && c != EOF )
      c=getc(PWCFile);
  }
			// ஢塞 ४⭮ ᠭ 䠢⮢
  for ( n=0; n < ItemCount; n++)
    if ( item.stru[n].AlphaNo > AlphabetNumber )
      return SignalError ( errInvalidAlphabetRef, PWCFileName );

  if (fclose(PWCFile))
    return SignalError (errPWCFileError, PWCFileName);
  else
    return O_K_;
}

// 㭪  ᫠ ஫

errList GetPWNumber (char *StringNumber)
{
  if ( ! isdigit ( *StringNumber ) )
    return SignalError (errBadPWNumber, StringNumber);
  for (PWNeed=0; isdigit(*StringNumber); StringNumber++)
    PWNeed *= 10, PWNeed += *StringNumber - '0';
  return *StringNumber ?
    SignalError (errBadPWNumber, StringNumber) :
    O_K_;
}

// 㭪 祭  뢮 ᯨ᪠ ஫

errList makePWs (char *TargetFileName)
{
  unsigned int PWCount,GroupNo,ByteLimit,power,i;
  unsigned char b;      // 㥬 
  FILE	*PWsFile;	// 䠩 ஫

  if ( (PWsFile= fopen(TargetFileName,"wt")) == NULL)
    return SignalError (errPWCFileError, TargetFileName);

  for ( PWCount=1; PWCount <= PWNeed; PWCount++)
  {
    if (PrintPWNo)	//   ஫, ᫨ 
      fprintf (PWsFile, "%4u ", PWCount);
    for ( GroupNo = 0; GroupNo < ItemCount; GroupNo++)
    {
      power = Alphabet[item.stru[GroupNo].AlphaNo-1].power;
      ByteLimit = (256 / power) * power;
      for ( i=0; i<item.stru[GroupNo].SymbolNo; i++ )
      {
	do
	  b = getRandomByte ();
	while ( b > ByteLimit );
	putc (Alphabet[item.stru[GroupNo].AlphaNo-1].alpha[b%power],
	      PWsFile);
      }
    }
    putc ('\n', PWsFile);
  }
  if (fclose(PWsFile))
    return SignalError (errPWCFileError, TargetFileName);
  else
    return O_K_;
}

// 祭    稪 砩 ⮢

unsigned char getRandomByte (void)
{
# define RANDOM_BLOCK_SIZE 8

  unsigned char static buffer[RANDOM_BLOCK_SIZE];
  static unsigned char *p = buffer + RANDOM_BLOCK_SIZE;

  if ( p == buffer + RANDOM_BLOCK_SIZE )
    gamme ( Key, chtab, Synchro, p=buffer, 1);
  return *(p++);
}
